//************************************************************************
//This module contains fitness case and functions to compute raw fitness *
//as well as standardized fitness for MultiPlexer Problems               *
//Programmed by NXH.                                                     *
//************************************************************************
#ifndef __MULTIPLEXER__
#define __MULTIPLEXER__

#include<iostream.h>
#include<string.h>
#include<stdio.h>
#include<assert.h>
#include<math.h>
#include<stdlib.h>
#include "gconst.h"
#include "random.h"
#include "term.h"
#include "stree.h"
#include  "genetic.h"
#define NUMADDRESS  2
#define NUMVAR  6
#define NUMFITCASE 64
struct _sample{
		 BOOL x[NUMVAR];
		 BOOL y;
		};
typedef struct _sample sample;
sample fitcase[NUMFITCASE];
BOOL SuccPredicate=FALSE;
void SetFitCase()
{
 int i,h,l,t;

 for(i=0;i<NUMFITCASE;i++)
  {
   //change to boonlean
   h=i;
   for(l=0;l<NUMVAR;l++)
    {
     if((h % 2)==1)
       fitcase[i].x[l]=TRUE;
     else
      fitcase[i].x[l]=FALSE;
     h=h/2;
    }
  //compute the address value
   h=0;
   t=1;
   for(l=0;l<NUMADDRESS;l++)
    {
     if(fitcase[i].x[l])
       h=h+t;
     t=t*2;
    }
    fitcase[i].y=fitcase[i].x[h+NUMADDRESS];
  }
}
//Some Boolean function
BOOL IF(BOOL a, BOOL b, BOOL c)
{
 if(a)
  return b;
 else
 return c;
}
BOOL AND(BOOL a, BOOL b)
{
 if (a&&b)
  return TRUE;
 else
  return FALSE;
}
BOOL OR(BOOL a,BOOL b)
{
 if(a||b)
  return TRUE;
 else
  return FALSE;
}
BOOL NOT(BOOL a)
{
 if(!a)
  return TRUE;
 else
 return FALSE;
}
//********************************************************************
//This function compute the function (in tree form) with given input *
//********************************************************************
BOOL Compute(node *st,BOOL x[NUMVAR])
{
 node *p,*q;
 BOOL l,r;
 if (!strcmp(st->name,"a0"))
     return x[0];
 if (!strcmp(st->name,"a1"))
      return x[1];
 if (!strcmp(st->name,"d0"))
     return x[2];
 if (!strcmp(st->name,"d1"))
     return x[3];
 if (!strcmp(st->name,"d2"))
      return x[4];
 if (!strcmp(st->name,"d3"))
      return x[5];
 q=st->children;
 if(!strcmp(st->name,"NOT"))//not
    return NOT(Compute(q,x));
 if(!strcmp(st->name,"IF"))
      return IF(Compute(q,x),Compute(q->sibling,x),Compute(q->sibling->sibling,x));
 if(!strcmp(st->name,"AND"))
	    return AND(Compute(q,x),Compute(q->sibling,x));
 else //OR
  return OR(Compute(q,x),Compute(q->sibling,x));
}
//*********************************************
//Compute the raw fitness for an invidual     *
//*********************************************
double ComputeRF(individual st)
{
  double sum=0;
  BOOL t;
  int i;
  int hit;
  hit=0;
  for(i=0;i<NUMFITCASE;i++)
   {
     t=Compute(st.chrom,fitcase[i].x);
     if(t==fitcase[i].y)
     {
      hit++;
      sum++;
     }
   }
   if(hit==NUMFITCASE)
     SuccPredicate=TRUE;
   return sum;
}
//****************************************************************
//This function initializes elementary trees and adjoining table *
//****************************************************************
void LoadTerm()
{
 cout<<endl<<"Loading terms...";
 InitTerm();
 AddTerm("IF",3);
 AddTerm("AND",2);
 AddTerm("OR",2);
 AddTerm("NOT",1);
 AddTerm("a0",0);
 AddTerm("a1",0);
 AddTerm("d0",0);
 AddTerm("d1",0);
 AddTerm("d2",0);
 AddTerm("d3",0);
// SwapTerm(100);
 cout<<endl<<"Done!";
}
#endif
