//This file contain SPEA2 implementation for multi-objective optimization
//Programmed by NXH
//#include<conio.h>//Delete this line if you are in Unix
#include<iostream.h>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<assert.h>
#include "gconst.h"
#include "random.h"
#include "term.h"
#include "stree.h"
#include "genetic.h"
//#include "mulplex.h"
#include "symreg.h"
#include "spea2.h"
FILE *fpfilename;
int cmldtype;
char cmloutpop[80],cmloutpar[80],cmloutstat[80],cmlfilename[80];
//*****************************************************
//This Function initializes for the program           *
//*****************************************************
void Init()
{
 //Initialize global variables
 //Loading Elementary trees and Adjoining Table
  LoadTerm();
 //Initialize population
  poplen=1000;
  alen=1000;
  oldpop=new pindividual[poplen+alen];assert(oldpop!=NULL);
  newpop=new pindividual[poplen+alen];assert(newpop!=NULL);
 // oldarchive=new pindividual[alen];assert(oldpop!=NULL);
  //newarchive=new pindividual[poplen];assert(newpop!=NULL);
 //Initialize Probabilities
  pcross=0.9;
  pmutate=0.1;
//Initializes satistics
  ncross=0;
  nmutate=0;
//Number of generations
  generation=26;
  bestcurrent=new individual[generation];assert(bestcurrent!=NULL);
  averagefitness=new double[generation];assert(averagefitness!=NULL);
  averagesfitness=new double[generation];assert(averagesfitness!=NULL);
  averagesize=new double[generation];assert(averagesize!=NULL);
//Some global variables
  SuccPredicate=FALSE;
  strongdominance=cmldtype;
//Set up fitness cases
//  SetFitCase();
}

FILE *Open_Text_File(char *filename)
{
 FILE *f;
 f=fopen(filename,"wt");
 if(f==NULL)
  {
   cout<<endl<<"Cannot create file!!!"<<filename<<endl;
   exit(1);
  }
 return f;
}
void pitoa(int i, char *ch)
{
 int j,k;
 char s[10],s1[10];
 k=10;
 strcpy(s,"");
 while(i>0)
  {
   j=i % k;
   s1[0]=j+'0';
   s1[1]=0;
   strcat(s1,s);
   strcpy(s,s1);
   i=i/k;
  }
 strcpy(ch, s);
}
main(int argc, char *argv[])
{
 int i,pos,j,runs,size,min2;
 char outpop[80],outpar[80],outstat[80],inpop[80];
 char temp[10];
 double min;
 long seed;
 if(argc!=6)
  {
   cout<<endl<<"Commandline Parameters Missing:"<<endl;
   cout<<"1- File name of the file containing input file name"<<endl;
   cout<<"2- Output Population file name"<<endl;
   cout<<"3- Output Pareto filename"<<endl;
   cout<<"4- Output Statistic File Name:"<<endl;
   cout<<"5- Pareto Dominance Type";
   exit(1);
  }
 strcpy(cmlfilename,argv[1]);
 fpfilename=fopen(cmlfilename,"rt");
 if(fpfilename==NULL)
  {
   cout<<endl<<"Cannot Read the file containing input file names!!!"<<endl;
   exit(1);
  }
 strcpy(cmloutpop,argv[2]);
 strcpy(cmloutpar,argv[3]);
 strcpy(cmloutstat,argv[4]);
 cmldtype=atoi(argv[5]);
 Init();
//InitRanGen();
//read the number of keys
 fscanf(fpfilename,"%d%*c",&runs);
for(i=1;i<=runs;i++)
{
 InitRanGen();
 fscanf(fpfilename,"%d%s%*c",&j,inpop);
 seed=j;
 pitoa(j,temp);
 strcpy(outpop,cmloutpop);
 strcat(outpop,temp);
 fppop=Open_Text_File(outpop);
 strcpy(outpar,cmloutpar);
 strcat(outpar,temp);
 fppar=Open_Text_File(outpar);
 strcpy(outstat,cmloutstat);
 strcat(outstat,temp);
 fpstat=Open_Text_File(outstat);
 Set_Seed(seed);//some (in many) other keys for successful induction of
 SetFitCase();
 SwapTerm(100);
 Evolution(inpop);
 for(j=0;j<gen;j++)
  {
   fprintf(fpstat,"%lf %d %lf %lf %lf\n",bestcurrent[j].fitness,bestcurrent[j].size,averagefitness[j],averagesfitness[j],averagesize[j]);
  }
 min=bestcurrent[0].fitness;
 pos=0;
 for(j=1;j<gen;j++)
   if(bestcurrent[j].fitness<min)
    {
     min=bestcurrent[j].fitness;
     pos=j;
    }
//with respect to the secondary fitness
   min2=bestcurrent[pos].size;
for(j=0;j<gen;j++)
 if(bestcurrent[j].fitness==min)
   {
    size=bestcurrent[j].size;
    if(size<min2)
     {
      min2=size;
      pos=j;
     }
   }
  fprintf(fpstat,"The best found at generation: %d\n",pos);
 // DeleteIntron(bestcurrent[pos]);
  fprintf(fpstat,"Fitness %lf and Size %d\n",bestcurrent[pos].fitness,min2);
  fprintf(fpstat,"Number of crossover:%ld\n",ncross);
  fprintf(fpstat,"Number of Replacement:%ld\n",nmutate);
  fclose(fppop);
  fclose(fppar);
  fclose(fpstat);
 }
fclose(fpfilename);
}
